#include <stdio.h>

#define DONTCARE '-'
#define TRUE      1
#define FALSE     0
#define ONE      '1'
#define ZERO     '0'

#define INPUTS   100
#define OUTPUTS  200
#define STATE    300
#define ILLEGAL   -1


struct DataItem
{   char *name;
    int  number;            /*Map to table index     */
    int  type;              /*State, Input, or Output*/
    struct DataItem *next;
};


struct StateVectorRow
/* The format of the state vector is:
 *   (old) Current State Bits, Inputs, Next State Bits, Outputs
 *   (new) Inputs, Current State Bits, Next State Bits, Outputs
 *         Note that the ordering of state bits is actually
 *         c<msb>c<msb-1>...c<lsb>n<lsb>n<lsb+1>...n<msb>
 */
{   char *bits;			  /*DONTCARE, ONE, or ZERO          */
    char *StateName;		  /*Name of the next state	    */
    struct StateVectorRow *next;  /*Link to other input combinations*/
};


struct State
{   char *name;
    struct StateVectorRow *vectors;
    struct State *next;
};

/*
**	Macros for performance
*/
#define ReadBitByNumber(Vector, Index)	((Vector)->bits[(Index)])
#define SetBitByNumber(Vector, Index, Level)  ((Vector)->bits[(Index)]=(Level))
