#include <stdio.h>
#include "stack.h"

#ifndef lint
static char sccsid[] = "@(#)stack.c	1.1 	TPLA (Berkeley) 3/11/83";
#endif  not lint

extern char *calloc();

/* returns true iff the stack 's' is empty */
int S_isempty(s)
STACK s;
{
    return (s == NULL);
}

/* pushes the char pointer 'p' onto the stack 's' */
S_push(s, p)
STACK *s;
char *p;
{
    S_CARRIER *car;

    car = (S_CARRIER *) calloc(1, sizeof(S_CARRIER));
    car->data = p;
    car->next = *s;
    *s = car;
}

/* pops from stack 's', returns a char pointer */
char *S_pop(s)
STACK *s;
{
    char *p;
    if (*s == NULL) {
	p = NULL;
    } else {
	S_CARRIER *sc;
	sc = *s;
	p = sc->data;
	*s = sc->next;
	cfree( (char *)sc);
    }
    return p;
}

/* returns true iff 'q' is empty */
int Q_isempty(q)
QUEUE q;
{
    return (q.front == NULL);
}


/* put 'p' onto the end of queue 'q' */
Q_push(q, p)
QUEUE *q;
char *p;
{
    Q_CARRIER *qc;
    qc = (Q_CARRIER *) calloc(1, sizeof(Q_CARRIER));
    qc->data = p;
    qc->next = NULL;
    if ( q->back != NULL ) q->back->next = qc;
    q->back = qc;
    if ( q->front == NULL ) q->front = qc;
}


/* pop an element off the front of the queue 'q' */
char *Q_pop(q)
QUEUE *q;
{
    char *p;
    if ( q->front == NULL ) {
	p = NULL;
    } else {
	Q_CARRIER *qc;
	qc = q->front;
	p = qc->data;
	if ( q->back == qc ) q->back = qc->next;
	q->front = qc->next;
	cfree( (char *)qc);
    }
    return p;
}


/******	test routine
main()
{
    char ch, *cp;
    QUEUE stk;

    setbuf(stdin, NULL);

    ch = getchar();
    while (ch != EOF) {
	if (ch == '^') {
	    if (Q_isempty(stk)) {
		printf("Stack is empty\n");
	    } else {
		cp = Q_pop(&stk);
		printf("Pop %c\n", *cp);
		cfree(cp);
	    }
	} else {
	    cp = calloc(1, sizeof(char));
	    *cp = ch;
	    Q_push(&stk, cp);
	    printf("Push %c\n", *cp);
	}
	ch = getchar();
    }
}

******/
