#include <stdio.h>
#include <string.h>
#include <ctype.h>

#ifndef lint
static char sccsid[] = "@(#)unio.c	1.1 	TPLA (Berkeley) 3/11/83";
#endif  not lint

/* extern char *sprintf(); */

#define	STRLEN	200
#define	INBUFSIZE 300

char inbuf[INBUFSIZE];	/* buffer for unget_ch */
int inbufp = 0;		/* next free position in inbuf */
char last_char = '\n';	/* the last character read */



char get_ch()  /* get a (possibly pushed back) character */
{
    char ch;

    if (inbufp > 0) {
	ch = inbuf[--inbufp];
	/** fprintf(stderr, "(%c)", ch); **/
    } else {
	ch = getchar();
	if (ch == EOF)
	    unio_error(1, "Attempt to read past end of file\n");
	while ( (last_char == '\n') && (ch == '#') ) {
	    while (ch != '\n') {
		ch = getchar();
		if (ch == EOF)
		    unio_error(1, "Attempt to read past end of file\n");
	    }
	    ch = getchar();
	    if (ch == EOF)
		unio_error(1, "Attempt to read past end of file\n");
	} 
	/** fprintf(stderr, "%c", ch); **/
    } 
    last_char = ch;
    return ch;
}



unget_ch(c)		/* push a character back into the input */
char c;
{
    if (inbufp > INBUFSIZE)
	unio_error(1, "too much lookahead (internal error)");
    else
	inbuf[inbufp++] = c;
}



char get_nonwhite()
{
    char ch;
    ch = get_ch();
    while( isspace(ch) && (ch !='\n') )
	ch = get_ch();
    return ch;
}


get_word(str)		/* get an input word (words are delimited 
			by white space) */
char *str;
{
    char ch;
    char *newstr;

    newstr = str;		/* assign pointers */
    ch = get_ch();
    while (isspace(ch) && (ch != '\n')) {
	ch = get_ch();
    }
    if (ch == '\n') {
	*newstr = '\n';
	newstr++;
    } else {
	while (!isspace(ch)) {
	    *newstr = ch;
	    newstr++;
	    ch = get_ch();
	}
	unget_ch(ch);
    }
    *newstr = '\0';
}




unget_word(str)		/* pusha word back into the input stream */
char *str;
{
    char *new;
    new = str;
    while(*new != '\0') new++;
    while(new != str) {
	new--;
	unget_ch(*new);
    }
}




get_newline()
{
    while(get_ch() != '\n') ;
}




unio_error(num, str)
int num;
char *str;
{
    fprintf(stderr, "(unio): %s.\n", str);
    if (num > 0) {
	exit(num);
    }
}

int get_num()
{
    int tot;
    char str[STRLEN], *strp;

    get_word(str);
    tot = 0;
    strp = str;
    while (*strp != '\0') {
	if ((*strp > '9') || (*strp < '0'))
	    unio_error(1, "strange character found inside of a number");
	else
	    tot = (tot * 10) + (*strp - '0');
	strp++;
    }
    return tot;
}



char lower(ch)
char ch;
{
    if (isupper(ch)) 
	return tolower(ch);
    else
	return ch;
}


lower_word(str)
char *str;
{
    while (*str != '\0') {
	if (isupper(*str))
	    *str = tolower(*str);
	str++;
    }
}


